<?php































class NotationService
{
private static $user;
private static $db_querier;
private static $lang;

public static function __static()
{
self::$user=AppContext::get_current_user();
self::$db_querier=PersistenceContext::get_querier();
self::$lang=LangLoader::get('main');
}






public static function display_static_image(Notation $notation)
{
$notation_scale=$notation->get_notation_scale();
if(!empty($notation_scale))
{
$average_notes=$notation->get_average_notes();

if($average_notes>0)
{
$template=new StringTemplate('
				# START notation #
					<img src="{PATH_TO_ROOT}/templates/{THEME}/images/{notation.PICTURE}" alt="" class="valign_middle" />
				# END notation #');

for($i=1;$i<=$notation_scale;$i++)
{
$star_img='stars.png';
if($average_notes<$i)
{
$decimal=$i-$average_notes;
if($decimal>=1)
$star_img='stars0.png';
elseif($decimal>=0.75)
$star_img='stars1.png';
elseif($decimal>=0.50)
$star_img='stars2.png';
else
$star_img='stars3.png';
}

$template->assign_block_vars('notation',array(
'PICTURE'=>$star_img
));
}
return $template->render();
}
else
{
return self::$lang['no_note'];
}
}
else
{
throw new NotationScaleIsEmptyException();
}
}





public static function display_active_image(Notation $notation)
{
$note_post=AppContext::get_request()->get_int('note',0);
$id_post=AppContext::get_request()->get_int('id',0);

if(!empty($note_post)&&!empty($id_post))
{
$notation->set_id_in_module($id_post);
$notation->set_note($note_post);
self::register_notation($notation);
}
else
{
$template=new FileTemplate('framework/content/notation/notation.tpl');

$average_notes=$notation->get_average_notes();

for($i=1;$i<=$notation->get_notation_scale();$i++)
{
$star_img='stars.png';
if($average_notes<$i)
{
$decimal=$i-$average_notes;
if($decimal>=1)
$star_img='stars0.png';
elseif($decimal>=0.75)
$star_img='stars1.png';
elseif($decimal>=0.50)
$star_img='stars2.png';
else
$star_img='stars3.png';
}

$template->assign_block_vars('notation',array(
'I'=>$i,
'PICTURE'=>$star_img
));

$template->assign_block_vars('notation_no_js',array(
'I'=>$i
));
}

$count_notes=$notation->get_number_notes();

$template->put_all(array(
'C_VOTES'=>$count_notes>0?true:false,
'C_MORE_1_NOTES'=>$count_notes>1?true:false,
'CURRENT_URL'=>REWRITED_SCRIPT,
'ID_IN_MODULE'=>$notation->get_id_in_module(),
'NOTATION_SCALE'=>$notation->get_notation_scale(),
'NUMBER_PIXEL'=>$notation->get_notation_scale()*16,
'NUMBER_NOTES'=>$count_notes,
'AVERAGE_NOTES'=>$average_notes,
'ALREADY_NOTE'=>$notation->user_already_noted(),
'L_NO_NOTE'=>self::$lang['no_note'],
'L_AUTH_ERROR'=>LangLoader::get_message('e_auth','errors'),
'L_ALREADY_NOTE'=>self::$lang['already_vote'],
'L_NOTES'=>self::$lang['notes'],
'L_NOTE'=>self::$lang['note'],
'L_VALID_NOTE'=>self::$lang['valid_note']
));

return $template->render();
}
}







public static function update_notation_scale($module_name,$old_notation_scale,$new_notation_scale)
{
if($old_notation_scale!==$new_notation_scale)
{
$coefficient=$new_notation_scale/$old_notation_scale;
self::$db_querier->inject("UPDATE ".DB_TABLE_AVERAGE_NOTES." SET average_notes = average_notes * ".$coefficient." WHERE module_name = '".$module_name."'");
self::$db_querier->inject("UPDATE ".DB_TABLE_NOTE." SET note = note * ".$coefficient." WHERE module_name = '".$module_name."'");
}
}






public static function delete_notes_id_in_module($module_name,$id_in_module)
{
try{
NotationDAO::delete_average_notes_by_id_in_module($module_name,$id_in_module);
NotationDAO::delete_notes_by_id_in_module($module_name,$id_in_module);
}catch(Exception $e){
}
}






public static function delete_notes_module($module_name)
{
try{
NotationDAO::delete_all_notes_by_module($module_name);
NotationDAO::delete_all_average_notes_by_module($module_name);
}catch(Exception $e){
}
}




public static function get_number_notes(Notation $notation)
{
try{
return self::$db_querier->get_column_value(DB_TABLE_AVERAGE_NOTES,'number_notes','WHERE module_name = :module_name AND id_in_module = :id_in_module',
array('module_name'=>$notation->get_module_name(),'id_in_module'=>$notation->get_id_in_module()));
}catch(RowNotFoundException $e){
return 0;
}
}




public static function get_average_notes(Notation $notation)
{
try{
return self::$db_querier->get_column_value(DB_TABLE_AVERAGE_NOTES,'average_notes','WHERE module_name = :module_name AND id_in_module = :id_in_module',
array('module_name'=>$notation->get_module_name(),'id_in_module'=>$notation->get_id_in_module()));
}catch(RowNotFoundException $e){
return 0;
}
}

private static function register_notation(Notation $notation)
{
if(self::$user->check_level(User::MEMBER_LEVEL))
{
$note_is_valid=$notation->get_note()>=0&&$notation->get_note()<=$notation->get_notation_scale()?true:false;
$member_already_notation=NotationDAO::get_member_already_notation($notation);

if(!$member_already_notation&&$note_is_valid)
{
NotationDAO::insert_note($notation);
$nbr_notes=NotationDAO::get_count_average_notes_by_id_in_module($notation);
if($nbr_notes==0)
{
NotationDAO::insert_average_notes($notation);
}
else
{
NotationDAO::update_average_notes($notation);
}
}
}
else
{
DispatchManager::redirect(PHPBoostErrors::user_not_authorized());
}
}
}
?>